{
  toAppRegistration = {
    port,
    id,
    as_token,
    hs_token,
    sender_localpart,
    rate_limited ? false,
    ...
  } @ conf:
    builtins.toJSON ({
        namespaces = {
          users = [
            {
              exclusive = true;
              regex = "^@${id}_.*:tristans.cloud$";
            }
            {
              exclusive = true;
              regex = "^@${id}bot:tristans.cloud$";
            }
          ];
        };
        url = "http://localhost:${toString port}";
      }
      // conf);
}
